import java.util.*;

public class Test {

    public static void main(String[] args) {

        Iterable<Integer> ci = new Interval(-10,10);
        for (int i : ci) System.out.println(i);

        ci = new Interval(3);
        int res = 0;
        for (int i : ci) {if (res++ >= 100) break; System.out.println(i);}

        for (int x: new Interval(Integer.MAX_VALUE, Integer.MAX_VALUE))
            System.out.println(x + " ");

        Tree<Integer> t =
            new Tree<Integer>(2,
                              new Tree<Integer>(1, null, null),
                              new Tree<Integer>(3, null, null));
        for (int i : t) System.out.print(i + " "); System.out.println();
        t = new Tree<Integer>(4, 
                              new Tree<Integer>(1,null,
                                                new Tree<Integer>(2,null,
                                                                  new Tree<Integer>(3,null,null))),
                              new Tree<Integer>(8, 
                                                new Tree<Integer>(6,
                                                                  new Tree<Integer>(5,null,null),
                                                                  new Tree<Integer>(7,null,null)),
                                                null));
        for (int i : t) System.out.print(i + " "); System.out.println();

        t = Tree.randomBST(15);
        Tree.print(t); System.out.println();
        for (int i : t) System.out.print(i + " "); System.out.println();

        Tree.inorder = false;
        t = Tree.randomPrefix(15);
        Tree.print(t); System.out.println();
        for (int i : t) System.out.print(i + " "); System.out.println();

        /*
        Integer[] a = {4,8,10};
        Integer[] b = {1,20};
        List<Integer> al = Arrays.asList(a);
        List<Integer> bl = Arrays.asList(b);
        Iterator<Integer> mi = new MergeIterator(al.iterator(),bl.iterator());
        while (mi.hasNext()) System.out.println(mi.next());
        */
    }

}